'\"
'\" Generated from file 'aitcs\&.man' by tcllib/doctools with format 'nroff'
'\" Copyright (c) 2020 Stuart Cassoff <stwo@users\&.sourceforge\&.net>
'\"
.TH "aitcs" n 1\&.6 aitcs "AitCS"
.\" The -*- nroff -*- definitions below are for supplemental macros used
.\" in Tcl/Tk manual entries.
.\"
.\" .AP type name in/out ?indent?
.\"	Start paragraph describing an argument to a library procedure.
.\"	type is type of argument (int, etc.), in/out is either "in", "out",
.\"	or "in/out" to describe whether procedure reads or modifies arg,
.\"	and indent is equivalent to second arg of .IP (shouldn't ever be
.\"	needed;  use .AS below instead)
.\"
.\" .AS ?type? ?name?
.\"	Give maximum sizes of arguments for setting tab stops.  Type and
.\"	name are examples of largest possible arguments that will be passed
.\"	to .AP later.  If args are omitted, default tab stops are used.
.\"
.\" .BS
.\"	Start box enclosure.  From here until next .BE, everything will be
.\"	enclosed in one large box.
.\"
.\" .BE
.\"	End of box enclosure.
.\"
.\" .CS
.\"	Begin code excerpt.
.\"
.\" .CE
.\"	End code excerpt.
.\"
.\" .VS ?version? ?br?
.\"	Begin vertical sidebar, for use in marking newly-changed parts
.\"	of man pages.  The first argument is ignored and used for recording
.\"	the version when the .VS was added, so that the sidebars can be
.\"	found and removed when they reach a certain age.  If another argument
.\"	is present, then a line break is forced before starting the sidebar.
.\"
.\" .VE
.\"	End of vertical sidebar.
.\"
.\" .DS
.\"	Begin an indented unfilled display.
.\"
.\" .DE
.\"	End of indented unfilled display.
.\"
.\" .SO ?manpage?
.\"	Start of list of standard options for a Tk widget. The manpage
.\"	argument defines where to look up the standard options; if
.\"	omitted, defaults to "options". The options follow on successive
.\"	lines, in three columns separated by tabs.
.\"
.\" .SE
.\"	End of list of standard options for a Tk widget.
.\"
.\" .OP cmdName dbName dbClass
.\"	Start of description of a specific option.  cmdName gives the
.\"	option's name as specified in the class command, dbName gives
.\"	the option's name in the option database, and dbClass gives
.\"	the option's class in the option database.
.\"
.\" .UL arg1 arg2
.\"	Print arg1 underlined, then print arg2 normally.
.\"
.\" .QW arg1 ?arg2?
.\"	Print arg1 in quotes, then arg2 normally (for trailing punctuation).
.\"
.\" .PQ arg1 ?arg2?
.\"	Print an open parenthesis, arg1 in quotes, then arg2 normally
.\"	(for trailing punctuation) and then a closing parenthesis.
.\"
.\"	# Set up traps and other miscellaneous stuff for Tcl/Tk man pages.
.if t .wh -1.3i ^B
.nr ^l \n(.l
.ad b
.\"	# Start an argument description
.de AP
.ie !"\\$4"" .TP \\$4
.el \{\
.   ie !"\\$2"" .TP \\n()Cu
.   el          .TP 15
.\}
.ta \\n()Au \\n()Bu
.ie !"\\$3"" \{\
\&\\$1 \\fI\\$2\\fP (\\$3)
.\".b
.\}
.el \{\
.br
.ie !"\\$2"" \{\
\&\\$1	\\fI\\$2\\fP
.\}
.el \{\
\&\\fI\\$1\\fP
.\}
.\}
..
.\"	# define tabbing values for .AP
.de AS
.nr )A 10n
.if !"\\$1"" .nr )A \\w'\\$1'u+3n
.nr )B \\n()Au+15n
.\"
.if !"\\$2"" .nr )B \\w'\\$2'u+\\n()Au+3n
.nr )C \\n()Bu+\\w'(in/out)'u+2n
..
.AS Tcl_Interp Tcl_CreateInterp in/out
.\"	# BS - start boxed text
.\"	# ^y = starting y location
.\"	# ^b = 1
.de BS
.br
.mk ^y
.nr ^b 1u
.if n .nf
.if n .ti 0
.if n \l'\\n(.lu\(ul'
.if n .fi
..
.\"	# BE - end boxed text (draw box now)
.de BE
.nf
.ti 0
.mk ^t
.ie n \l'\\n(^lu\(ul'
.el \{\
.\"	Draw four-sided box normally, but don't draw top of
.\"	box if the box started on an earlier page.
.ie !\\n(^b-1 \{\
\h'-1.5n'\L'|\\n(^yu-1v'\l'\\n(^lu+3n\(ul'\L'\\n(^tu+1v-\\n(^yu'\l'|0u-1.5n\(ul'
.\}
.el \}\
\h'-1.5n'\L'|\\n(^yu-1v'\h'\\n(^lu+3n'\L'\\n(^tu+1v-\\n(^yu'\l'|0u-1.5n\(ul'
.\}
.\}
.fi
.br
.nr ^b 0
..
.\"	# VS - start vertical sidebar
.\"	# ^Y = starting y location
.\"	# ^v = 1 (for troff;  for nroff this doesn't matter)
.de VS
.if !"\\$2"" .br
.mk ^Y
.ie n 'mc \s12\(br\s0
.el .nr ^v 1u
..
.\"	# VE - end of vertical sidebar
.de VE
.ie n 'mc
.el \{\
.ev 2
.nf
.ti 0
.mk ^t
\h'|\\n(^lu+3n'\L'|\\n(^Yu-1v\(bv'\v'\\n(^tu+1v-\\n(^Yu'\h'-|\\n(^lu+3n'
.sp -1
.fi
.ev
.\}
.nr ^v 0
..
.\"	# Special macro to handle page bottom:  finish off current
.\"	# box/sidebar if in box/sidebar mode, then invoked standard
.\"	# page bottom macro.
.de ^B
.ev 2
'ti 0
'nf
.mk ^t
.if \\n(^b \{\
.\"	Draw three-sided box if this is the box's first page,
.\"	draw two sides but no top otherwise.
.ie !\\n(^b-1 \h'-1.5n'\L'|\\n(^yu-1v'\l'\\n(^lu+3n\(ul'\L'\\n(^tu+1v-\\n(^yu'\h'|0u'\c
.el \h'-1.5n'\L'|\\n(^yu-1v'\h'\\n(^lu+3n'\L'\\n(^tu+1v-\\n(^yu'\h'|0u'\c
.\}
.if \\n(^v \{\
.nr ^x \\n(^tu+1v-\\n(^Yu
\kx\h'-\\nxu'\h'|\\n(^lu+3n'\ky\L'-\\n(^xu'\v'\\n(^xu'\h'|0u'\c
.\}
.bp
'fi
.ev
.if \\n(^b \{\
.mk ^y
.nr ^b 2
.\}
.if \\n(^v \{\
.mk ^Y
.\}
..
.\"	# DS - begin display
.de DS
.RS
.nf
.sp
..
.\"	# DE - end display
.de DE
.fi
.RE
.sp
..
.\"	# SO - start of list of standard options
.de SO
'ie '\\$1'' .ds So \\fBoptions\\fR
'el .ds So \\fB\\$1\\fR
.SH "STANDARD OPTIONS"
.LP
.nf
.ta 5.5c 11c
.ft B
..
.\"	# SE - end of list of standard options
.de SE
.fi
.ft R
.LP
See the \\*(So manual entry for details on the standard options.
..
.\"	# OP - start of full description for a single option
.de OP
.LP
.nf
.ta 4c
Command-Line Name:	\\fB\\$1\\fR
Database Name:	\\fB\\$2\\fR
Database Class:	\\fB\\$3\\fR
.fi
.IP
..
.\"	# CS - begin code excerpt
.de CS
.RS
.nf
.ta .25i .5i .75i 1i
..
.\"	# CE - end code excerpt
.de CE
.fi
.RE
..
.\"	# UL - underline word
.de UL
\\$1\l'|0\(ul'\\$2
..
.\"	# QW - apply quotation marks to word
.de QW
.ie '\\*(lq'"' ``\\$1''\\$2
.\"" fix emacs highlighting
.el \\*(lq\\$1\\*(rq\\$2
..
.\"	# PQ - apply parens and quotation marks to word
.de PQ
.ie '\\*(lq'"' (``\\$1''\\$2)\\$3
.\"" fix emacs highlighting
.el (\\*(lq\\$1\\*(rq\\$2)\\$3
..
.\"	# QR - quoted range
.de QR
.ie '\\*(lq'"' ``\\$1''\\-``\\$2''\\$3
.\"" fix emacs highlighting
.el \\*(lq\\$1\\*(rq\\-\\*(lq\\$2\\*(rq\\$3
..
.\"	# MT - "empty" string
.de MT
.QW ""
..
.BS
.SH NAME
aitcs \- Array in the Command's Shadow
.SH SYNOPSIS
package require \fBTcl  8\&.6\fR
.sp
package require \fBaitcs  ?1\&.6?\fR
.sp
namespace import ::aitcs::aitcs
.sp
\fBaitcs name\fR \fIname\fR ?\fIvariable_namespace\fR?
.sp
\fBaitcs new\fR ?\fIname\fR? ?\fIcommand_namespace\fR? ?\fIvariable_namespace\fR? ?\fIkey val\&.\&.\&.\fR?
.sp
\fBname!\fR
.sp
\fBname\fR \fIkey\fR ?\fIval\fR? ?\fIkey val\&.\&.\&.\fR?
.sp
\fBname?\fR \fIkey\fR ?\fImyVar\fR?
.sp
\fBname-\fR \fIkey\fR ?\fIkey \&.\&.\&.\fR?
.sp
\fBname^\fR \fIkey\fR ?\fIdefault\fR? ?\fImyVar\fR?
.sp
\fBname&\fR ?\fIkey\fR?
.sp
\fBname&&\fR
.sp
\fBname=\fR \fIkey\fR ?\fIkey \&.\&.\&.\fR? \fIval\fR
.sp
\fBname+\fR \fIkey\fR ?\fIval \&.\&.\&.\fR?
.sp
\fBname+=\fR \fIkey\fR ?\fIincr\fR?
.sp
\fBname\&.\fR \fIkey?op?\fR ?\fIarg \&.\&.\&.\fR?
.sp
\fBname---\fR
.sp
.BE
.SH DESCRIPTION
An Array in the Command's Shadow is an array with an
associated set of commands that each provide access to
or allow certain useful manipulations of the array\&.
.PP
An AitCS may be used where a program would
normally use global or namespace variables to hold
configuration, state, widget paths, temp values, etc\&.
.PP
Arrays are named+randomly-named and created in a
namespace\&. Several commands (via aliases) are created in a
(possibly different) namespace to manipulate the array\&.
.PP
The name ends up being used much like the set command\&.
.PP
The inspiration came from being tired of
having to use the variable command in almost all
the procs in a namespace when often in a
given proc there is interest only in a few
items in the global state\&.
.PP
By reducing array manipulation clutter this
extension may help in improving program clarity!
.SH COMMANDS
.TP
\fBaitcs name\fR \fIname\fR ?\fIvariable_namespace\fR?
Names a new array in the namespace \fIvariable_namespace\fR\&.
The format of the name is "namespace::__name__cccccc_"
where "cccccc" is six random characters in the range a-z\&.
If \fIvariable_namespace\fR isn't supplied or
is an empty string then the array will be named in
the caller's namespace\&. Doesn't create an array variable\&.
Returns the name of the newly named array\&.
.TP
\fBaitcs new\fR ?\fIname\fR? ?\fIcommand_namespace\fR? ?\fIvariable_namespace\fR? ?\fIkey val\&.\&.\&.\fR?
Creates a new array in the namespace \fIvariable_namespace\fR
and creates commands (via aliases) in the \fIcommand_namespace\fR to
manipulate the array\&. The format of the name and the
\fIvariable_namespace\fR will be as described in the
\fBname\fR ensemble subcommand\&. If the \fIname\fR isn't supplied
or is an empty string then the \fIname\fR will be set to a string of six
random characters in the range a-z\&. If the \fIcommand_namespace\fR
isn't supplied or is an empty string then the
\fIcommand_namespace\fR will be set to the \fIvariable_namespace\fR\&.
The commands (via aliases) are created in the \fIcommand_namespace\fR\&.
Initial values are set from \fIkey val\&.\&.\&.\fR if supplied\&.
See the AITCS COMMANDS section\&.
Creates an array variable in the \fIvariable_namespace\fR\&.
Returns the name of the newly named array, or the randomly-generated
\fIname\fR if the \fIname\fR argument wasn't supplied\&.
.PP
.SH "AITCS COMMANDS"
Commands (via aliases) are created in the \fIcommand_namespace\fR and
are based on the name supplied when the array was created\&.
.TP
\fBname!\fR
Causes the array to come into existence in the current context\&.
This is \fBupvar\fR \fI#0\fR \fIvarname\fR \fIname\fR\&.
From then on in the current context the array can be referenced by name\&.
Returns an empty string\&.
Nickname: Make Exist\&.
.TP
\fBname\fR \fIkey\fR ?\fIval\fR? ?\fIkey val\&.\&.\&.\fR?
Gets the value of one element of the array or sets the value of one or more elements of the array\&.
The value(s) for the key(s) will be set using \fBarray set\fR\&.
Returns the value at \fIkey\fR\&.
Nickname: Get/Set\&.
.TP
\fBname?\fR \fIkey\fR ?\fImyVar\fR?
Returns true if the \fIkey\fR exists in the array or false if the \fIkey\fR doesn't exist in the array\&.
If the \fIkey\fR exists and \fImyVar\fR is supplied and is not an empty string then the variable it names
will be set in the caller's context to the value at \fIkey\fR\&.
Nickname: Exists\&.
.TP
\fBname-\fR \fIkey\fR ?\fIkey \&.\&.\&.\fR?
Removes key(s) from the array\&. The \fBarray unset\fR command is used, allowing key(s) to contain wildcards\&.
It isn't an error if a key doesn't exist in the array\&.
Returns an empty string\&.
Nickname: Unset\&.
.TP
\fBname^\fR \fIkey\fR ?\fIdefault\fR? ?\fImyVar\fR?
Returns the value at \fIkey\fR if it exists,
otherwise returns \fIdefault\fR, or an empty string if \fIdefault\fR isn't supplied\&.
If \fImyVar\fR is supplied and is not an empty string then the variable it names
will be set in the caller's context to the returned value\&.
Nickname: Get With Default\&.
.TP
\fBname&\fR ?\fIkey\fR?
Returns the fully namespace qualified name of the array if no \fIkey\fR supplied or if \fIkey\fR is an empty string,
otherwise returns the fully namespace qualified name of the array and the element \fIkey\fR\&.
Nickname: Variable Reference\&.
.TP
\fBname&&\fR
Returns the fully namespace qualified command\&.
Nickname: Command Reference\&.
.TP
\fBname=\fR \fIkey\fR ?\fIkey \&.\&.\&.\fR? \fIval\fR
Every \fIkey\fR is set to \fIval\fR\&.
Returns \fIval\fR\&.
Nickname: Setto\&.
.TP
\fBname+\fR \fIkey\fR ?\fIval \&.\&.\&.\fR?
Every \fIval\fR is lappended to the element at \fIkey\fR\&.
Returns the value at \fIkey\fR\&.
Nickname: Lappend\&.
.TP
\fBname+=\fR \fIkey\fR ?\fIincr\fR?
Increments the value at \fIkey\fR by \fIincr\fR (default 1)\&.
Returns the value at \fIkey\fR\&.
Nickname: Incr\&.
.TP
\fBname\&.\fR \fIkey?op?\fR ?\fIarg \&.\&.\&.\fR?
The \fIkey\fR should be another AitCS\&. Permits "nesting"\&. Calls are chained\&.
Nickname: Struct Dereference\&.
.TP
\fBname---\fR
Unsets the array and deletes all the commands\&.
Returns an empty string\&.
Nickname: Destroy\&.
.PP
.SH EXAMPLES
.CS



	# Set/Get/Variable Reference
	# Save a widget and link a textvariable
	aitcs new rec
	aitcs new gui
	set fld preference
	rec $fld Tcl
	gui $fld [entry \&.e -textvariable [rec& $fld]]
	[gui $fld] insert end /Tk
	string length [rec preference]; # 6

	# Get/Set
	aitcs new things
	things a 3
	things b [expr {[things a] + 2}]
	things c [expr {[things b] * [things a]}]
	things c; # 15

	# Exists
	aitcs new colours
	colours red #FF0000
	colours? red; # 1
	colours? green; # 0
	colours? red color1; # 1
	info exists color1; # 1
	set color1; # #FF0000
	colours? green color2; # 0
	info exists color2; # 0

	# Setto/Exists/Unset/Variable Reference
	aitcs new fruits
	fruits= apple orange pear apricot 0
	if {![fruits? peach]} {
		fruits= peach 0
	}
	array names [fruits&]; # {apple orange pear apricot peach}
	fruits- p* a*
	array names [fruits&]; # {orange}

	# Get With Default
	aitcs new things
	things are good
	things^ are ok; # good
	things^ be ok; # ok
	things^ willbe; # Empty string
	things^ is nice here; # nice, and var here is set to nice

	# Lappend
	aitcs new store
	store this one
	store+ this two three four five
	store this; # {one two three four five}

	# Incr
	aitcs new counters
	counters cycles 0
	counters+= cycles
	counters+= cycles 2
	counters+= cycles -1
	counters cycles; # 2

	# Make Exist/Exists
	aitcs new cow
	cow!
	set cow(sound) moo
	if {[cow? sound] && $cow(sound) eq "moo"} {
		puts "Standard English Cow"
	}

	# Command Reference/Variable Reference/Incr
	aitcs new callback
	callback count 0
	after 1000 [list [callback&&]+= count]
	vwait [callback& count]
	callback count; # 1

	# Struct Dereference/Random Name/Initial Values
	aitcs new animals {} {}  dog [aitcs new {} {} {} says woof likes cat]  cat [aitcs new {} {} {} says meow likes dog]
	animals home [list dog cat]
	set res ""; foreach animal [animals home] {
		append res $animal " says " [animals\&. $animal says]
		append res " likes " [animals\&. $animal likes]
		append res " who says " [animals\&. [animals\&. $animal likes] says]\\n
        }
	set res
	# dog says woof likes cat who says meow
	# cat says meow likes dog who says woof

	# Struct Dereference
	aitcs new outer
	aitcs new inner
	aitcs new innest
	inner count 6
	innest things [list]
	innest+ things 1 2
	outer member inner
	inner item innest
	outer\&. member+= count 2; # 8
	outer\&. member\&. item+ things 3 4; # {1 2 3 4}
	outer\&. member\&. item^ name; # Empty string

	# Destroy
	aitcs new tmp
	tmp count 5
	tmp+= count -1
	tmp count; # 4
	set fqarr [tmp&]
	info exists $fqarr; # 1
	tmp---
	info exists $fqarr; # 0
	tmp count; # <error>


.CE
.SH KEYWORDS
alias, array, command, eagle, namespace, snake
.SH CATEGORY
Programming tools
.SH COPYRIGHT
.nf
Copyright (c) 2020 Stuart Cassoff <stwo@users\&.sourceforge\&.net>

.fi